diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/test/wifi-phy-ofdma-test.cc ns-3.42/src/wifi/test/wifi-phy-ofdma-test.cc
--- ns-3.41/src/wifi/test/wifi-phy-ofdma-test.cc	2024-02-09 14:44:08.617795200 -0800
+++ ns-3.42/src/wifi/test/wifi-phy-ofdma-test.cc	2024-05-29 15:29:47.220074000 -0700
@@ -41,6 +41,7 @@
 #include "ns3/string.h"
 #include "ns3/test.h"
 #include "ns3/threshold-preamble-detection-model.h"
+#include "ns3/txop.h"
 #include "ns3/waveform-generator.h"
 #include "ns3/wifi-mac-header.h"
 #include "ns3/wifi-net-device.h"
@@ -2501,7 +2502,9 @@
     m_phy = CreateObject<OfdmaSpectrumWifiPhy>(0);
     Ptr<InterferenceHelper> interferenceHelper = CreateObject<InterferenceHelper>();
     Ptr<ErrorRateModel> error = CreateObject<NistErrorRateModel>();
-    Ptr<ApWifiMac> mac = CreateObject<ApWifiMac>();
+    auto mac = CreateObjectWithAttributes<ApWifiMac>(
+        "Txop",
+        PointerValue(CreateObjectWithAttributes<Txop>("AcIndex", StringValue("AC_BE_NQOS"))));
     mac->SetAttribute("BeaconGeneration", BooleanValue(false));
     dev->SetMac(mac);
     m_phy->SetInterferenceHelper(interferenceHelper);
@@ -3716,7 +3719,9 @@
     Ptr<Node> apNode = CreateObject<Node>();
     Ptr<WifiNetDevice> apDev = CreateObject<WifiNetDevice>();
     apDev->SetStandard(WIFI_STANDARD_80211ax);
-    Ptr<ApWifiMac> apMac = CreateObject<ApWifiMac>();
+    auto apMac = CreateObjectWithAttributes<ApWifiMac>(
+        "Txop",
+        PointerValue(CreateObjectWithAttributes<Txop>("AcIndex", StringValue("AC_BE_NQOS"))));
     apMac->SetAttribute("BeaconGeneration", BooleanValue(false));
     apDev->SetMac(apMac);
     m_phyAp = CreateObject<OfdmaSpectrumWifiPhy>(0);
@@ -5074,7 +5079,9 @@
 
     Ptr<Node> apNode = CreateObject<Node>();
     Ptr<WifiNetDevice> apDev = CreateObject<WifiNetDevice>();
-    Ptr<ApWifiMac> apMac = CreateObject<ApWifiMac>();
+    auto apMac = CreateObjectWithAttributes<ApWifiMac>(
+        "Txop",
+        PointerValue(CreateObjectWithAttributes<Txop>("AcIndex", StringValue("AC_BE_NQOS"))));
     apMac->SetAttribute("BeaconGeneration", BooleanValue(false));
     apDev->SetMac(apMac);
     m_phyAp = CreateObject<OfdmaSpectrumWifiPhy>(0);
@@ -5838,15 +5845,15 @@
 };
 
 WifiPhyOfdmaTestSuite::WifiPhyOfdmaTestSuite()
-    : TestSuite("wifi-phy-ofdma", UNIT)
+    : TestSuite("wifi-phy-ofdma", Type::UNIT)
 {
-    AddTestCase(new TestDlOfdmaPhyTransmission, TestCase::QUICK);
-    AddTestCase(new TestDlOfdmaPhyPuncturing, TestCase::QUICK);
-    AddTestCase(new TestUlOfdmaPpduUid, TestCase::QUICK);
-    AddTestCase(new TestMultipleHeTbPreambles, TestCase::QUICK);
-    AddTestCase(new TestUlOfdmaPhyTransmission, TestCase::QUICK);
-    AddTestCase(new TestPhyPaddingExclusion, TestCase::QUICK);
-    AddTestCase(new TestUlOfdmaPowerControl, TestCase::QUICK);
+    AddTestCase(new TestDlOfdmaPhyTransmission, TestCase::Duration::QUICK);
+    AddTestCase(new TestDlOfdmaPhyPuncturing, TestCase::Duration::QUICK);
+    AddTestCase(new TestUlOfdmaPpduUid, TestCase::Duration::QUICK);
+    AddTestCase(new TestMultipleHeTbPreambles, TestCase::Duration::QUICK);
+    AddTestCase(new TestUlOfdmaPhyTransmission, TestCase::Duration::QUICK);
+    AddTestCase(new TestPhyPaddingExclusion, TestCase::Duration::QUICK);
+    AddTestCase(new TestUlOfdmaPowerControl, TestCase::Duration::QUICK);
 }
 
 static WifiPhyOfdmaTestSuite wifiPhyOfdmaTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/test/wifi-phy-reception-test.cc ns-3.42/src/wifi/test/wifi-phy-reception-test.cc
--- ns-3.41/src/wifi/test/wifi-phy-reception-test.cc	2024-02-09 14:44:08.617795200 -0800
+++ ns-3.42/src/wifi/test/wifi-phy-reception-test.cc	2024-05-29 15:29:47.220074000 -0700
@@ -4706,12 +4706,15 @@
     /**
      * Callback invoked when the PHY model starts to process a signal
      *
-     * \param signalType whether signal is WiFi (true) or foreign (false)
+     * \param signal the arriving signal
      * \param senderNodeId node Id of the sender of the signal
      * \param rxPower received signal power (dBm)
      * \param duration signal duration
      */
-    void RxBegin(bool signalType, uint32_t senderNodeId, double rxPower, Time duration);
+    void RxBegin(Ptr<const SpectrumSignalParameters> signal,
+                 uint32_t senderNodeId,
+                 double rxPower,
+                 Time duration);
 
     /**
      * Send function (sends a single packet)
@@ -4768,12 +4771,13 @@
 }
 
 void
-TestSpectrumChannelWithBandwidthFilter::RxBegin(bool signalType [[maybe_unused]],
+TestSpectrumChannelWithBandwidthFilter::RxBegin(Ptr<const SpectrumSignalParameters> signal
+                                                [[maybe_unused]],
                                                 uint32_t senderNodeId [[maybe_unused]],
                                                 double rxPower [[maybe_unused]],
                                                 Time duration [[maybe_unused]])
 {
-    NS_LOG_FUNCTION(this << signalType << senderNodeId << rxPower << duration);
+    NS_LOG_FUNCTION(this << signal << senderNodeId << rxPower << duration);
     m_countRxBegin++;
 }
 
@@ -4852,6 +4856,174 @@
  * \ingroup wifi-test
  * \ingroup tests
  *
+ * \brief This test verifies that the WifiPhyRxfailureReason distinguishes between two cases:  1) a
+ * drop due to transmitting during the signal detection interval, and 2) a drop due to transmitting
+ * after the receiver has detected a preamble but is waiting for the end of the preamble. 2
+ * SpectrumWifiPhy are setup and connected on the same spectrum channel. The test will send a packet
+ * over the channel and after a controlled amount of transmit delay (to check both cases) the
+ * receiver of the packet will send its own packet. If delay is less than preamble detection period,
+ * the signal detection should be aborted by transmission. If delay is greater than preamble
+ * detection period, the signal reception should be aborted by transmission.
+ */
+class TestPhyDropDueToTx : public TestCase
+{
+  public:
+    /**
+     * Constructor
+     *
+     * \param delay delay in microseconds to send second packet
+     * \param expectedReason expected failure reason
+     */
+    TestPhyDropDueToTx(Time delay, WifiPhyRxfailureReason expectedReason);
+
+  protected:
+    void DoSetup() override;
+    void DoTeardown() override;
+
+  private:
+    /**
+     * RX dropped function
+     * \param p the packet
+     * \param reason the reason
+     */
+    void PhyDropTraceSink(Ptr<const Packet> p, WifiPhyRxfailureReason reason);
+
+    /**
+     * Send function (sends a single packet)
+     * \param phy the WifiPhy object to send the packet
+     */
+    void Send(Ptr<WifiPhy> phy) const;
+
+    /**
+     * Event scheduled at end of simulation for validation
+     */
+    void CheckDropReason();
+
+    void DoRun() override;
+
+    Ptr<SpectrumWifiPhy> m_phyA{nullptr}; ///< transmit function
+    Ptr<SpectrumWifiPhy> m_phyB{nullptr}; ///< transmit/receive function
+
+    Time m_delay; ///< delay between transmissions in MicroSeconds
+
+    WifiPhyRxfailureReason m_expectedReason; ///< expected WifiPhyRxfailureReason
+    WifiPhyRxfailureReason m_observedReason; ///< observed WifiPhyRxfailureReason
+};
+
+TestPhyDropDueToTx::TestPhyDropDueToTx(Time delay, WifiPhyRxfailureReason expectedReason)
+    : TestCase("Test for correct WifiPhyRxfailureReason from PhyRxDrop trace"),
+      m_delay(delay),
+      m_expectedReason(expectedReason)
+{
+}
+
+void
+TestPhyDropDueToTx::Send(Ptr<WifiPhy> phy) const
+{
+    const auto txVector =
+        WifiTxVector(HePhy::GetHeMcs0(), 0, WIFI_PREAMBLE_HE_SU, 800, 1, 1, 0, 20, false);
+
+    auto pkt = Create<Packet>(1000);
+    WifiMacHeader hdr;
+
+    hdr.SetType(WIFI_MAC_QOSDATA);
+    hdr.SetQosTid(0);
+
+    auto psdu = Create<WifiPsdu>(pkt, hdr);
+    phy->Send(psdu, txVector);
+}
+
+void
+TestPhyDropDueToTx::CheckDropReason()
+{
+    NS_TEST_ASSERT_MSG_EQ(m_expectedReason,
+                          m_observedReason,
+                          "Packet was dropped due to the wrong drop reason reported ");
+}
+
+void
+TestPhyDropDueToTx::PhyDropTraceSink(Ptr<const Packet> p, WifiPhyRxfailureReason reason)
+{
+    NS_LOG_FUNCTION(this << p << reason);
+    m_observedReason = reason;
+}
+
+void
+TestPhyDropDueToTx::DoSetup()
+{
+    NS_LOG_FUNCTION(this);
+    auto channel = CreateObject<SingleModelSpectrumChannel>();
+
+    auto node = CreateObject<Node>();
+    auto devA = CreateObject<WifiNetDevice>();
+    m_phyA = CreateObject<SpectrumWifiPhy>();
+    m_phyA->SetDevice(devA);
+    m_phyA->SetTxPowerStart(20);
+    m_phyA->SetTxPowerEnd(20);
+
+    auto nodeRx = CreateObject<Node>();
+    auto devB = CreateObject<WifiNetDevice>();
+    m_phyB = CreateObject<SpectrumWifiPhy>();
+    m_phyB->SetDevice(devB);
+    m_phyB->SetTxPowerStart(20);
+    m_phyB->SetTxPowerEnd(20);
+
+    auto interferenceTx = CreateObject<InterferenceHelper>();
+    m_phyA->SetInterferenceHelper(interferenceTx);
+    auto errorTx = CreateObject<NistErrorRateModel>();
+    m_phyA->SetErrorRateModel(errorTx);
+
+    auto interferenceRx = CreateObject<InterferenceHelper>();
+    m_phyB->SetInterferenceHelper(interferenceRx);
+    auto errorRx = CreateObject<NistErrorRateModel>();
+    m_phyB->SetErrorRateModel(errorRx);
+
+    m_phyA->AddChannel(channel);
+    m_phyB->AddChannel(channel);
+
+    m_phyA->ConfigureStandard(WIFI_STANDARD_80211ax);
+    m_phyA->SetOperatingChannel(WifiPhy::ChannelTuple{36, 0, WIFI_PHY_BAND_5GHZ, 0});
+
+    m_phyB->ConfigureStandard(WIFI_STANDARD_80211ax);
+    m_phyB->SetOperatingChannel(WifiPhy::ChannelTuple{36, 0, WIFI_PHY_BAND_5GHZ, 0});
+
+    devA->SetPhy(m_phyA);
+    node->AddDevice(devA);
+    devB->SetPhy(m_phyB);
+    nodeRx->AddDevice(devB);
+
+    m_phyB->TraceConnectWithoutContext("PhyRxDrop",
+                                       MakeCallback(&TestPhyDropDueToTx::PhyDropTraceSink, this));
+}
+
+void
+TestPhyDropDueToTx::DoTeardown()
+{
+    m_phyA->Dispose();
+    m_phyB->Dispose();
+}
+
+void
+TestPhyDropDueToTx::DoRun()
+{
+    NS_LOG_FUNCTION(this);
+
+    Simulator::ScheduleNow(&TestPhyDropDueToTx::Send, this, m_phyA);
+    Simulator::Schedule(m_delay, &TestPhyDropDueToTx::Send, this, m_phyB);
+
+    // Upon transmitting the second packet from m_phyB, the reception from
+    // m_phyA will be immediately dropped.  Check the drop reason a short
+    // while later (1 ns is sufficient)
+    Simulator::Schedule(m_delay + NanoSeconds(1), &TestPhyDropDueToTx::CheckDropReason, this);
+
+    Simulator::Run();
+    Simulator::Destroy();
+}
+
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
  * \brief wifi PHY reception Test Suite
  */
 class WifiPhyReceptionTestSuite : public TestSuite
@@ -4861,24 +5033,33 @@
 };
 
 WifiPhyReceptionTestSuite::WifiPhyReceptionTestSuite()
-    : TestSuite("wifi-phy-reception", UNIT)
+    : TestSuite("wifi-phy-reception", Type::UNIT)
 {
-    AddTestCase(new TestThresholdPreambleDetectionWithoutFrameCapture, TestCase::QUICK);
-    AddTestCase(new TestThresholdPreambleDetectionWithFrameCapture, TestCase::QUICK);
-    AddTestCase(new TestSimpleFrameCaptureModel, TestCase::QUICK);
-    AddTestCase(new TestPhyHeadersReception, TestCase::QUICK);
-    AddTestCase(new TestAmpduReception, TestCase::QUICK);
-    AddTestCase(new TestUnsupportedModulationReception(), TestCase::QUICK);
-    AddTestCase(new TestUnsupportedBandwidthReception(), TestCase::QUICK);
-    AddTestCase(new TestPrimary20CoveredByPpdu(), TestCase::QUICK);
+    AddTestCase(new TestThresholdPreambleDetectionWithoutFrameCapture, TestCase::Duration::QUICK);
+    AddTestCase(new TestThresholdPreambleDetectionWithFrameCapture, TestCase::Duration::QUICK);
+    AddTestCase(new TestSimpleFrameCaptureModel, TestCase::Duration::QUICK);
+    AddTestCase(new TestPhyHeadersReception, TestCase::Duration::QUICK);
+    AddTestCase(new TestAmpduReception, TestCase::Duration::QUICK);
+    AddTestCase(new TestUnsupportedModulationReception(), TestCase::Duration::QUICK);
+    AddTestCase(new TestUnsupportedBandwidthReception(), TestCase::Duration::QUICK);
+    AddTestCase(new TestPrimary20CoveredByPpdu(), TestCase::Duration::QUICK);
     // The below three test cases are related.  The test involves a receiver tuned to
     // channel 36 and a transmitter sending on channels 36, 40, and 44, respectively.
     // The second argument corresponds to the number of signals expected to be received.
     // Signals on channel 36 and 40 will fall within the receiver bandwidth, while
     // a signal on channel 44 will fall completely outside and will be filtered.
-    AddTestCase(new TestSpectrumChannelWithBandwidthFilter(36, 1), TestCase::QUICK);
-    AddTestCase(new TestSpectrumChannelWithBandwidthFilter(40, 1), TestCase::QUICK);
-    AddTestCase(new TestSpectrumChannelWithBandwidthFilter(44, 0), TestCase::QUICK);
+    AddTestCase(new TestSpectrumChannelWithBandwidthFilter(36, 1), TestCase::Duration::QUICK);
+    AddTestCase(new TestSpectrumChannelWithBandwidthFilter(40, 1), TestCase::Duration::QUICK);
+    AddTestCase(new TestSpectrumChannelWithBandwidthFilter(44, 0), TestCase::Duration::QUICK);
+    AddTestCase(new TestSpectrumChannelWithBandwidthFilter(36, 1), TestCase::Duration::QUICK);
+    AddTestCase(new TestSpectrumChannelWithBandwidthFilter(40, 1), TestCase::Duration::QUICK);
+    AddTestCase(new TestSpectrumChannelWithBandwidthFilter(44, 0), TestCase::Duration::QUICK);
+    // 4 Microseconds is just less than the preamble detection period since there is no
+    // propagation delay model
+    AddTestCase(new TestPhyDropDueToTx(MicroSeconds(4), SIGNAL_DETECTION_ABORTED_BY_TX),
+                TestCase::Duration::QUICK);
+    AddTestCase(new TestPhyDropDueToTx(MicroSeconds(5), RECEPTION_ABORTED_BY_TX),
+                TestCase::Duration::QUICK);
 }
 
 static WifiPhyReceptionTestSuite wifiPhyReceptionTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/test/wifi-phy-thresholds-test.cc ns-3.42/src/wifi/test/wifi-phy-thresholds-test.cc
--- ns-3.41/src/wifi/test/wifi-phy-thresholds-test.cc	2024-02-09 14:44:08.617795200 -0800
+++ ns-3.42/src/wifi/test/wifi-phy-thresholds-test.cc	2024-05-29 15:29:47.220074000 -0700
@@ -499,12 +499,12 @@
 };
 
 WifiPhyThresholdsTestSuite::WifiPhyThresholdsTestSuite()
-    : TestSuite("wifi-phy-thresholds", UNIT)
+    : TestSuite("wifi-phy-thresholds", Type::UNIT)
 {
-    AddTestCase(new WifiPhyThresholdsWeakWifiSignalTest, TestCase::QUICK);
-    AddTestCase(new WifiPhyThresholdsWeakForeignSignalTest, TestCase::QUICK);
-    AddTestCase(new WifiPhyThresholdsStrongWifiSignalTest, TestCase::QUICK);
-    AddTestCase(new WifiPhyThresholdsStrongForeignSignalTest, TestCase::QUICK);
+    AddTestCase(new WifiPhyThresholdsWeakWifiSignalTest, TestCase::Duration::QUICK);
+    AddTestCase(new WifiPhyThresholdsWeakForeignSignalTest, TestCase::Duration::QUICK);
+    AddTestCase(new WifiPhyThresholdsStrongWifiSignalTest, TestCase::Duration::QUICK);
+    AddTestCase(new WifiPhyThresholdsStrongForeignSignalTest, TestCase::Duration::QUICK);
 }
 
 static WifiPhyThresholdsTestSuite wifiPhyThresholdsTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/test/wifi-primary-channels-test.cc ns-3.42/src/wifi/test/wifi-primary-channels-test.cc
--- ns-3.41/src/wifi/test/wifi-primary-channels-test.cc	2024-02-09 14:44:08.617795200 -0800
+++ ns-3.42/src/wifi/test/wifi-primary-channels-test.cc	2024-05-29 15:29:47.220074000 -0700
@@ -1370,19 +1370,19 @@
 };
 
 WifiPrimaryChannelsTestSuite::WifiPrimaryChannelsTestSuite()
-    : TestSuite("wifi-primary-channels", UNIT)
+    : TestSuite("wifi-primary-channels", Type::UNIT)
 {
     // Test cases for 20 MHz can be added, but are not that useful (there would be a single BSS)
-    AddTestCase(new WifiPrimaryChannelsTest(40, true), TestCase::QUICK);
-    AddTestCase(new WifiPrimaryChannelsTest(40, false), TestCase::QUICK);
+    AddTestCase(new WifiPrimaryChannelsTest(40, true), TestCase::Duration::QUICK);
+    AddTestCase(new WifiPrimaryChannelsTest(40, false), TestCase::Duration::QUICK);
 #if 0
     // Tests disabled until issue #776 resolved
-    AddTestCase(new WifiPrimaryChannelsTest(80, true), TestCase::EXTENSIVE);
-    AddTestCase(new WifiPrimaryChannelsTest(80, false), TestCase::EXTENSIVE);
-    AddTestCase(new WifiPrimaryChannelsTest(160, true), TestCase::TAKES_FOREVER);
-    AddTestCase(new WifiPrimaryChannelsTest(160, false), TestCase::TAKES_FOREVER);
+    AddTestCase(new WifiPrimaryChannelsTest(80, true), TestCase::Duration::EXTENSIVE);
+    AddTestCase(new WifiPrimaryChannelsTest(80, false), TestCase::Duration::EXTENSIVE);
+    AddTestCase(new WifiPrimaryChannelsTest(160, true), TestCase::Duration::TAKES_FOREVER);
+    AddTestCase(new WifiPrimaryChannelsTest(160, false), TestCase::Duration::TAKES_FOREVER);
 #endif
-    AddTestCase(new Wifi20MHzChannelIndicesTest(), TestCase::QUICK);
+    AddTestCase(new Wifi20MHzChannelIndicesTest(), TestCase::Duration::QUICK);
 }
 
 static WifiPrimaryChannelsTestSuite g_wifiPrimaryChannelsTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/test/wifi-ru-allocation-test.cc ns-3.42/src/wifi/test/wifi-ru-allocation-test.cc
--- ns-3.41/src/wifi/test/wifi-ru-allocation-test.cc	2024-02-09 14:44:08.617795200 -0800
+++ ns-3.42/src/wifi/test/wifi-ru-allocation-test.cc	2024-05-29 15:29:47.220074000 -0700
@@ -688,9 +688,9 @@
 };
 
 WifiRuAllocationTestSuite::WifiRuAllocationTestSuite()
-    : TestSuite("wifi-ru-allocation", UNIT)
+    : TestSuite("wifi-ru-allocation", Type::UNIT)
 {
-    AddTestCase(new Wifi20MHzIndicesCoveringRuTest(), TestCase::QUICK);
+    AddTestCase(new Wifi20MHzIndicesCoveringRuTest(), TestCase::Duration::QUICK);
 }
 
 static WifiRuAllocationTestSuite g_wifiRuAllocationTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/test/wifi-test.cc ns-3.42/src/wifi/test/wifi-test.cc
--- ns-3.41/src/wifi/test/wifi-test.cc	2024-02-09 14:44:08.617795200 -0800
+++ ns-3.42/src/wifi/test/wifi-test.cc	2024-05-29 15:29:47.220074000 -0700
@@ -26,7 +26,7 @@
 #include "ns3/constant-position-mobility-model.h"
 #include "ns3/error-model.h"
 #include "ns3/fcfs-wifi-queue-scheduler.h"
-#include "ns3/frame-exchange-manager.h"
+#include "ns3/he-frame-exchange-manager.h"
 #include "ns3/header-serialization-test.h"
 #include "ns3/ht-configuration.h"
 #include "ns3/interference-helper.h"
@@ -159,17 +159,21 @@
     auto manager = m_manager.Create<WifiRemoteStationManager>();
     dev->SetRemoteStationManager(manager);
 
-    Ptr<WifiMac> mac = m_mac.Create<WifiMac>();
+    auto txop = CreateObjectWithAttributes<Txop>("AcIndex", StringValue("AC_BE_NQOS"));
+    m_mac.Set("Txop", PointerValue(txop));
+    auto mac = m_mac.Create<WifiMac>();
     mac->SetDevice(dev);
     mac->SetAddress(Mac48Address::Allocate());
     dev->SetMac(mac);
-    mac->ConfigureStandard(WIFI_STANDARD_80211a);
+    mac->SetChannelAccessManagers({CreateObject<ChannelAccessManager>()});
+    mac->SetFrameExchangeManagers({CreateObject<FrameExchangeManager>()});
     if (mac->GetTypeOfStation() == STA)
     {
         StaticCast<StaWifiMac>(mac)->SetAssocManager(CreateObject<WifiDefaultAssocManager>());
     }
     mac->SetMacQueueScheduler(CreateObject<FcfsWifiQueueScheduler>());
     Ptr<FrameExchangeManager> fem = mac->GetFrameExchangeManager();
+    fem->SetAddress(mac->GetAddress());
     Ptr<WifiProtectionManager> protectionManager = CreateObject<WifiDefaultProtectionManager>();
     protectionManager->SetWifiMac(mac);
     fem->SetProtectionManager(protectionManager);
@@ -352,13 +356,17 @@
     auto manager = m_manager.Create<WifiRemoteStationManager>();
     dev->SetRemoteStationManager(manager);
 
-    Ptr<WifiMac> mac = m_mac.Create<WifiMac>();
+    auto txop = CreateObjectWithAttributes<Txop>("AcIndex", StringValue("AC_BE_NQOS"));
+    m_mac.Set("Txop", PointerValue(txop));
+    auto mac = m_mac.Create<WifiMac>();
     mac->SetDevice(dev);
     mac->SetAddress(Mac48Address::Allocate());
     dev->SetMac(mac);
-    mac->ConfigureStandard(WIFI_STANDARD_80211a);
+    mac->SetChannelAccessManagers({CreateObject<ChannelAccessManager>()});
+    mac->SetFrameExchangeManagers({CreateObject<FrameExchangeManager>()});
     mac->SetMacQueueScheduler(CreateObject<FcfsWifiQueueScheduler>());
     Ptr<FrameExchangeManager> fem = mac->GetFrameExchangeManager();
+    fem->SetAddress(mac->GetAddress());
     Ptr<WifiProtectionManager> protectionManager = CreateObject<WifiDefaultProtectionManager>();
     protectionManager->SetWifiMac(mac);
     fem->SetProtectionManager(protectionManager);
@@ -570,13 +578,17 @@
     txDev->SetRemoteStationManager(m_manager.Create<WifiRemoteStationManager>());
     txNode->AddDevice(txDev);
 
+    auto txop = CreateObjectWithAttributes<Txop>("AcIndex", StringValue("AC_BE_NQOS"));
+    m_mac.Set("Txop", PointerValue(txop));
     auto txMac = m_mac.Create<WifiMac>();
     txMac->SetDevice(txDev);
     txMac->SetAddress(Mac48Address::Allocate());
     txDev->SetMac(txMac);
-    txMac->ConfigureStandard(WIFI_STANDARD_80211a);
+    txMac->SetChannelAccessManagers({CreateObject<ChannelAccessManager>()});
+    txMac->SetFrameExchangeManagers({CreateObject<FrameExchangeManager>()});
     txMac->SetMacQueueScheduler(CreateObject<FcfsWifiQueueScheduler>());
     auto fem = txMac->GetFrameExchangeManager();
+    fem->SetAddress(txMac->GetAddress());
     auto protectionManager = CreateObject<WifiDefaultProtectionManager>();
     protectionManager->SetWifiMac(txMac);
     fem->SetProtectionManager(protectionManager);
@@ -1849,13 +1861,21 @@
     mac.SetTypeId("ns3::ApWifiMac");
     mac.Set("EnableBeaconJitter", BooleanValue(false));
     mac.Set("QosSupported", BooleanValue(true));
-    Ptr<WifiMac> apMac = mac.Create<WifiMac>();
+    for (const std::string ac : {"BE", "BK", "VI", "VO"})
+    {
+        auto qosTxop =
+            CreateObjectWithAttributes<QosTxop>("AcIndex", StringValue(std::string("AC_") + ac));
+        mac.Set(ac + "_Txop", PointerValue(qosTxop));
+    }
+    auto apMac = mac.Create<WifiMac>();
     apMac->SetDevice(apDev);
     apMac->SetAddress(Mac48Address::Allocate());
     apDev->SetMac(apMac);
-    apMac->ConfigureStandard(WIFI_STANDARD_80211ax);
+    apMac->SetChannelAccessManagers({CreateObject<ChannelAccessManager>()});
+    apMac->SetFrameExchangeManagers({CreateObject<HeFrameExchangeManager>()});
     apMac->SetMacQueueScheduler(CreateObject<FcfsWifiQueueScheduler>());
     Ptr<FrameExchangeManager> fem = apMac->GetFrameExchangeManager();
+    fem->SetAddress(apMac->GetAddress());
     Ptr<WifiProtectionManager> protectionManager = CreateObject<WifiDefaultProtectionManager>();
     protectionManager->SetWifiMac(apMac);
     fem->SetProtectionManager(protectionManager);
@@ -1887,14 +1907,22 @@
     m_staPhy->SetOperatingChannel(WifiPhy::ChannelTuple{36, 20, WIFI_PHY_BAND_5GHZ, 0});
 
     mac.SetTypeId("ns3::StaWifiMac");
+    for (const std::string ac : {"BE", "BK", "VI", "VO"})
+    {
+        auto qosTxop =
+            CreateObjectWithAttributes<QosTxop>("AcIndex", StringValue(std::string("AC_") + ac));
+        mac.Set(ac + "_Txop", PointerValue(qosTxop));
+    }
     auto staMac = mac.Create<WifiMac>();
     staDev->SetMac(staMac);
     staMac->SetDevice(staDev);
     staMac->SetAddress(Mac48Address::Allocate());
-    staMac->ConfigureStandard(WIFI_STANDARD_80211ax);
+    staMac->SetChannelAccessManagers({CreateObject<ChannelAccessManager>()});
+    staMac->SetFrameExchangeManagers({CreateObject<HeFrameExchangeManager>()});
     StaticCast<StaWifiMac>(staMac)->SetAssocManager(CreateObject<WifiDefaultAssocManager>());
     staMac->SetMacQueueScheduler(CreateObject<FcfsWifiQueueScheduler>());
     fem = staMac->GetFrameExchangeManager();
+    fem->SetAddress(staMac->GetAddress());
     protectionManager = CreateObject<WifiDefaultProtectionManager>();
     protectionManager->SetWifiMac(staMac);
     fem->SetProtectionManager(protectionManager);
@@ -3791,26 +3819,26 @@
 };
 
 WifiTestSuite::WifiTestSuite()
-    : TestSuite("wifi-devices", UNIT)
+    : TestSuite("wifi-devices", Type::UNIT)
 {
-    AddTestCase(new WifiTest, TestCase::QUICK);
-    AddTestCase(new QosUtilsIsOldPacketTest, TestCase::QUICK);
-    AddTestCase(new InterferenceHelperSequenceTest, TestCase::QUICK); // Bug 991
-    AddTestCase(new DcfImmediateAccessBroadcastTestCase, TestCase::QUICK);
-    AddTestCase(new Bug730TestCase, TestCase::QUICK); // Bug 730
-    AddTestCase(new QosFragmentationTestCase, TestCase::QUICK);
-    AddTestCase(new SetChannelFrequencyTest, TestCase::QUICK);
-    AddTestCase(new Bug2222TestCase, TestCase::QUICK);            // Bug 2222
-    AddTestCase(new Bug2843TestCase, TestCase::QUICK);            // Bug 2843
-    AddTestCase(new Bug2831TestCase, TestCase::QUICK);            // Bug 2831
-    AddTestCase(new StaWifiMacScanningTestCase, TestCase::QUICK); // Bug 2399
-    AddTestCase(new Bug2470TestCase, TestCase::QUICK);            // Bug 2470
-    AddTestCase(new Issue40TestCase, TestCase::QUICK);            // Issue #40
-    AddTestCase(new Issue169TestCase, TestCase::QUICK);           // Issue #169
-    AddTestCase(new IdealRateManagerChannelWidthTest, TestCase::QUICK);
-    AddTestCase(new IdealRateManagerMimoTest, TestCase::QUICK);
-    AddTestCase(new HeRuMcsDataRateTestCase, TestCase::QUICK);
-    AddTestCase(new WifiMgtHeaderTest, TestCase::QUICK);
+    AddTestCase(new WifiTest, TestCase::Duration::QUICK);
+    AddTestCase(new QosUtilsIsOldPacketTest, TestCase::Duration::QUICK);
+    AddTestCase(new InterferenceHelperSequenceTest, TestCase::Duration::QUICK); // Bug 991
+    AddTestCase(new DcfImmediateAccessBroadcastTestCase, TestCase::Duration::QUICK);
+    AddTestCase(new Bug730TestCase, TestCase::Duration::QUICK); // Bug 730
+    AddTestCase(new QosFragmentationTestCase, TestCase::Duration::QUICK);
+    AddTestCase(new SetChannelFrequencyTest, TestCase::Duration::QUICK);
+    AddTestCase(new Bug2222TestCase, TestCase::Duration::QUICK);            // Bug 2222
+    AddTestCase(new Bug2843TestCase, TestCase::Duration::QUICK);            // Bug 2843
+    AddTestCase(new Bug2831TestCase, TestCase::Duration::QUICK);            // Bug 2831
+    AddTestCase(new StaWifiMacScanningTestCase, TestCase::Duration::QUICK); // Bug 2399
+    AddTestCase(new Bug2470TestCase, TestCase::Duration::QUICK);            // Bug 2470
+    AddTestCase(new Issue40TestCase, TestCase::Duration::QUICK);            // Issue #40
+    AddTestCase(new Issue169TestCase, TestCase::Duration::QUICK);           // Issue #169
+    AddTestCase(new IdealRateManagerChannelWidthTest, TestCase::Duration::QUICK);
+    AddTestCase(new IdealRateManagerMimoTest, TestCase::Duration::QUICK);
+    AddTestCase(new HeRuMcsDataRateTestCase, TestCase::Duration::QUICK);
+    AddTestCase(new WifiMgtHeaderTest, TestCase::Duration::QUICK);
 }
 
 static WifiTestSuite g_wifiTestSuite; ///< the test suite
